#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers  7
#property indicator_color1 Orange
#property indicator_width1 1
#property indicator_color2 Gold
#property indicator_width2 1
#property indicator_color3 Green
#property indicator_width3 1
#property indicator_color4 Blue
#property indicator_width4 1
#property indicator_color5 Black
#property indicator_width5 1
#property indicator_color6 Red
#property indicator_width6 1
#property indicator_color7 Magenta
#property indicator_width7 1

#property indicator_level1 0
#property indicator_levelwidth 2
#property indicator_levelstyle 0
#property indicator_levelcolor Red


extern int prd = 48;
extern string suffix = "";

int fontsize=8;

//---- buffers
double cci_aud[];
double cci_jpy[];
double cci_chf[];
double cci_eur[];
double cci_usd[];
double cci_gbp[];
double cci_cad[];

extern int perioda = PERIOD_H4;

int init()
{
	IndicatorBuffers(7);
	
	SetIndexStyle (0, DRAW_LINE);
   SetIndexBuffer(0, cci_aud);
   SetIndexLabel(0, "AUD");

	SetIndexStyle (1, DRAW_LINE);
   SetIndexBuffer(1, cci_jpy);
   SetIndexLabel(1, "JPY");

	SetIndexStyle (2, DRAW_LINE);
   SetIndexBuffer(2, cci_chf);
   SetIndexLabel(2, "CHF");

	SetIndexStyle (3, DRAW_LINE);
   SetIndexBuffer(3, cci_eur);
   SetIndexLabel(3, "EUR");

	SetIndexStyle (4, DRAW_LINE);
   SetIndexBuffer(4, cci_gbp);
   SetIndexLabel(4, "GBP");

	SetIndexStyle (5, DRAW_LINE);
   SetIndexBuffer(5, cci_usd);
   SetIndexLabel(5, "USD");

	SetIndexStyle (6, DRAW_LINE);
   SetIndexBuffer(6, cci_cad);
   SetIndexLabel(6, "CAD");
   
   string mena = "EUR";
   
   ObjectCreate(mena,OBJ_TEXT,WindowFind("!cci_sum"),Time[0], 0);
   ObjectSetText(mena, mena,fontsize);
   ObjectSet(mena,OBJPROP_COLOR, Blue);
   
   mena = "GBP";
   ObjectCreate(mena,OBJ_TEXT,WindowFind("!cci_sum"),Time[0], 0);
   ObjectSetText(mena, mena,fontsize);
   ObjectSet(mena,OBJPROP_COLOR, Black);
      
   mena = "USD";
   ObjectCreate(mena,OBJ_TEXT,WindowFind("!cci_sum"),Time[0], 0);
   ObjectSetText(mena, mena,fontsize);
   ObjectSet(mena,OBJPROP_COLOR, Red);
      
   mena = "CHF";
   ObjectCreate(mena,OBJ_TEXT,WindowFind("!cci_sum"),Time[0], 0);
   ObjectSetText(mena, mena,fontsize);
   ObjectSet(mena,OBJPROP_COLOR, Green);
      
   mena = "JPY";
   ObjectCreate(mena,OBJ_TEXT,WindowFind("!cci_sum"),Time[0], 0);
   ObjectSetText(mena, mena,fontsize);
   ObjectSet(mena,OBJPROP_COLOR, Gold);
      
   mena = "AUD";
   ObjectCreate(mena,OBJ_TEXT,WindowFind("!cci_sum"),Time[0], 0);
   ObjectSetText(mena, mena,fontsize);
   ObjectSet(mena,OBJPROP_COLOR, Orange);
      
   mena = "CAD";
   ObjectCreate(mena,OBJ_TEXT,WindowFind("!cci_sum"),Time[0], 0);
   ObjectSetText(mena, mena,fontsize);
   ObjectSet(mena,OBJPROP_COLOR, Magenta);   

	return(0);
}

int deinit()
{
   return(0);
   ObjectDelete("gbp");
   ObjectDelete("usd");
   ObjectDelete("eur");
   ObjectDelete("jpy");
   ObjectDelete("aud");
   ObjectDelete("cad");
   ObjectDelete("chf");   
}

int start()
{
   double ccival;		
   string mena, str;
   int j;
   int denominator = 6;
   int counted_bars = IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   int limit = Bars-counted_bars;
   
   string aud_pairs[] = {"EURAUD", "GBPAUD", "AUDCHF", "AUDJPY", "AUDCAD", "AUDUSD" };
   string jpy_pairs[] = {"USDJPY", "EURJPY", "AUDJPY", "CHFJPY", "CADJPY", "GBPJPY" };
   string gbp_pairs[] = {"GBPUSD", "EURGBP", "GBPAUD", "GBPCHF", "GBPCAD", "GBPJPY" };
   string usd_pairs[] = {"GBPUSD", "EURUSD", "AUDUSD", "USDCHF", "USDCAD", "USDJPY" };
   string cad_pairs[] = {"GBPCAD", "EURCAD", "AUDCAD", "CADCHF", "USDCAD", "CADJPY" };
   string eur_pairs[] = {"EURGBP", "EURUSD", "EURAUD", "EURCHF", "EURCAD", "EURJPY" };
   string chf_pairs[] = {"EURCHF", "USDCHF", "AUDCHF", "GBPCHF", "CADCHF", "CHFJPY" };



	for (int i = limit-1; i >= 0; i--)
	{
	   cci_aud[i] = 0;
      mena = "AUD";	   
      for( j = 0; j < ArraySize(aud_pairs); j++)
      {
         str = aud_pairs[j] + suffix;
         ccival = iCCI(str, perioda, prd, PRICE_CLOSE, i);
         if(StringSubstr(str, 0, 3) == mena)
            cci_aud[i] = cci_aud[i] + ccival;
         else
            cci_aud[i] = cci_aud[i] - ccival;
     	}
     	cci_aud[i] /= denominator;

	   cci_jpy[i] = 0;
      mena = "JPY";
      for( j = 0; j < ArraySize(jpy_pairs); j++)
      {
         str = jpy_pairs[j] + suffix;
         ccival = iCCI(str, perioda, prd, PRICE_CLOSE, i);
         if(StringSubstr(str, 0, 3) == mena)
            cci_jpy[i] = cci_jpy[i] + ccival;
         else
            cci_jpy[i] = cci_jpy[i] - ccival;
     	}
     	cci_jpy[i] /= denominator;


	   cci_usd[i] = 0;
      mena = "USD";
      for( j = 0; j < ArraySize(usd_pairs); j++)
      {
         str = usd_pairs[j] + suffix;
         ccival = iCCI(str, perioda, prd, PRICE_CLOSE, i);
         if(StringSubstr(str, 0, 3) == mena)
            cci_usd[i] = cci_usd[i] + ccival;
         else
            cci_usd[i] = cci_usd[i] - ccival;
     	}
     	cci_usd[i] /= denominator;

	   cci_eur[i] = 0;
      mena = "EUR";
      for( j = 0; j < ArraySize(eur_pairs); j++)
      {
         str = eur_pairs[j] + suffix;
         ccival = iCCI(str, perioda, prd, PRICE_CLOSE, i);
         if(StringSubstr(str, 0, 3) == mena)
            cci_eur[i] = cci_eur[i] + ccival;
         else
            cci_eur[i] = cci_eur[i] - ccival;
     	}
     	cci_eur[i] /= denominator;

	   cci_chf[i] = 0;
      mena = "CHF";
      for( j = 0; j < ArraySize(chf_pairs); j++)
      {
         str = chf_pairs[j] + suffix;
         ccival = iCCI(str, perioda, prd, PRICE_CLOSE, i);
         if(StringSubstr(str, 0, 3) == mena)
            cci_chf[i] = cci_chf[i] + ccival;
         else
            cci_chf[i] = cci_chf[i] - ccival;
     	}
     	cci_chf[i] /= denominator;

	   cci_cad[i] = 0;
      mena = "CAD";
      for( j = 0; j < ArraySize(cad_pairs); j++)
      {
         str = cad_pairs[j] + suffix;
         ccival = iCCI(str, perioda, prd, PRICE_CLOSE, i);
         if(StringSubstr(str, 0, 3) == mena)
            cci_cad[i] = cci_cad[i] + ccival;
         else
            cci_cad[i] = cci_cad[i] - ccival;
     	}
     	cci_cad[i] /= denominator;

	   cci_gbp[i] = 0;
      mena = "GBP";
      for( j = 0; j < ArraySize(gbp_pairs); j++)
      {
         str = gbp_pairs[j] + suffix;
         ccival = iCCI(str, perioda, prd, PRICE_CLOSE, i);
         if(StringSubstr(str, 0, 3) == mena)
            cci_gbp[i] = cci_gbp[i] + ccival;
         else
            cci_gbp[i] = cci_gbp[i] - ccival;
     	}
     	cci_gbp[i] /= denominator;
   
	}
		
	
	
	int k;
	k = Time[0];
	
	k = k + 50000;
	
	int offset;
	offset = 11;
	string menak;
	double val;	
	
	menak = "EUR";
	val = cci_eur[0];
	ObjectSetText(menak,menak+"="+ DoubleToStr(val,0));
	ObjectSet(menak, OBJPROP_TIME1, k);
	ObjectSet(menak, OBJPROP_PRICE1,val+offset);
	menak = "USD";
	val = cci_usd[0];
	ObjectSetText(menak,menak+"="+ DoubleToStr(val,0));
	ObjectSet(menak, OBJPROP_TIME1, k);
	ObjectSet(menak, OBJPROP_PRICE1,val+offset);	
	menak = "CHF";
	val = cci_chf[0];
	ObjectSetText(menak,menak+"="+ DoubleToStr(val,0));
	ObjectSet(menak, OBJPROP_TIME1, k);
	ObjectSet(menak, OBJPROP_PRICE1,val+offset);		
	menak = "AUD";
	val = cci_aud[0];
	ObjectSetText(menak,menak+"="+ DoubleToStr(val,0));
	ObjectSet(menak, OBJPROP_TIME1, k);
	ObjectSet(menak, OBJPROP_PRICE1,val+offset);	
	menak = "CAD";
	val = cci_cad[0];
	ObjectSetText(menak,menak+"="+ DoubleToStr(val,0));
	ObjectSet(menak, OBJPROP_TIME1, k);
	ObjectSet(menak, OBJPROP_PRICE1,val+offset);	
		menak = "JPY";
	val = cci_jpy[0];
	ObjectSetText(menak,menak+"="+ DoubleToStr(val,0));
	ObjectSet(menak, OBJPROP_TIME1, k);
	ObjectSet(menak, OBJPROP_PRICE1,val+offset);		

   
	menak = "GBP";
	val = cci_gbp[0];
	ObjectSetText(menak,menak+"="+ DoubleToStr(val,0));
	ObjectSet(menak, OBJPROP_TIME1, k);
	ObjectSet(menak, OBJPROP_PRICE1,val+offset);	   
	   return(0);
}


